/*************************************************************************
 *
 *  $RCSfile: sc_typemap.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:38:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <bf_svx/svxids.hrc>
#include "bf_sc.hrc"
#include "scitems.hxx"


#define ITEMID_ADJUST			0
#define ITEMID_CASEMAP			0
#define	ITEMID_DBTYPE			0
#define ITEMID_LINESPACE		0
#define ITEMID_INTERLINESPACE  	0
#define ITEMID_BREAK  			0
#define ITEMID_NUMTYPE  		0
#define ITEMID_SHADOWLOCATION  	0
#define ITEMID_PAGE				0
#define ITEMID_PAGEMODEL  		0
#define ITEMID_ORPHANS			0
#define ITEMID_KERNING			0
#define ITEMID_POSTITDATE		0
#define ITEMID_TEXT				0
#define ITEMID_AUTHOR			0
#define ITEMID_DATE				0
#define ITEMID_SIZE				0
#define ITEMID_HYPHENZONE 		0
#define ITEMID_FMTSPLIT 		0
#define ITEMID_FMTKEEP	 		0
#define ITEMID_FMTBREAK 		0
#define ITEMID_AUTOKERN			0
#define ITEMID_LONGLRSPACE		0
#define ITEMID_LONGULSPACE		0
#define ITEMID_WIDOWS			0


// auto strip #include <bf_sfx2/msg.hxx>
#include <svtools/stritem.hxx>
#include <svtools/slstitm.hxx>
#include <bf_sfx2/objitem.hxx>
#include <bf_svx/fontitem.hxx>
#include <bf_svx/hlnkitem.hxx>
// auto strip #include <bf_svx/srchitem.hxx>
#include <bf_svx/postattr.hxx>
#include <bf_svx/postitem.hxx>
#include <bf_sfx2/tplpitem.hxx>
#include <bf_svx/zoomitem.hxx>
#include <bf_svx/brshitem.hxx>
#include <bf_svx/wghtitem.hxx>
#include <bf_svx/fhgtitem.hxx>
#include <bf_svx/colritem.hxx>
#include <bf_svx/boxitem.hxx>
#include <bf_svx/bolnitem.hxx>
#include <svtools/ptitem.hxx>
#include <bf_svx/sizeitem.hxx>
#include <bf_svx/algitem.hxx>
#include <bf_svx/clipfmtitem.hxx>
#include <bf_svx/udlnitem.hxx>
#include <bf_svx/xlnstit.hxx>
#include <bf_svx/xlnedit.hxx>
#include <bf_svx/xfillit0.hxx>
#include <bf_svx/xflclit.hxx>
// auto strip #include <bf_svx/xgrad.hxx>
#include <bf_svx/xflgrit.hxx>
#include <bf_svx/xflhtit.hxx>
#include <bf_svx/xbtmpit.hxx>
#include <bf_svx/xlineit0.hxx>
#include <bf_svx/xlndsit.hxx>
#include <bf_svx/xlnwtit.hxx>
#include <bf_svx/xlnclit.hxx>
#include <bf_svx/xtextit0.hxx>
#include <bf_svx/xftadit.hxx>
#include <bf_svx/xftdiit.hxx>
#include <bf_svx/xftstit.hxx>
#include <bf_svx/xftmrit.hxx>
#include <bf_svx/xftouit.hxx>
#include <bf_svx/xftshit.hxx>
#include <bf_svx/xftshcit.hxx>
#include <bf_svx/xftshxy.hxx>
#include <bf_svx/xftsfit.hxx>
#include <bf_svx/langitem.hxx>
#include <bf_svx/grafctrl.hxx>
#include <bf_svx/shdditem.hxx>
#include <bf_svx/shaditem.hxx>
#include <bf_svx/cntritem.hxx>
#include <bf_svx/crsditem.hxx>
// auto strip #include <bf_svx/brkitem.hxx>
#include <bf_svx/charreliefitem.hxx>
#include <bf_svx/rotmodit.hxx>
#include <svtools/ilstitem.hxx>
#include <svtools/globalnameitem.hxx>

#include "attrib.hxx"

#define SvxDrawToolItem             SfxEnumItem
#define SvxDrawAlignItem			SfxEnumItem
#define SvxChooseControlItem		SfxEnumItem

#ifndef _SFX_SRCHITEM_HXX
#include <bf_sfx2/srchitem.hxx>
#endif

namespace binfilter {
#define SFX_TYPEMAP
#include "scslots.hxx"


}
