/*************************************************************************
 *
 *  $RCSfile: acredlin.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:29:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_ACREDLIN_HXX
#define SC_ACREDLIN_HXX

#ifndef _MOREBTN_HXX //autogen
#include <vcl/morebtn.hxx>
#endif
#ifndef _COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif
#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _HEADBAR_HXX //autogen
#include <svtools/headbar.hxx>
#endif

#ifndef _SVTABBX_HXX //autogen
#include <svtools/svtabbx.hxx>
#endif


#ifndef SC_RANGENAM_HXX
#include "rangenam.hxx"
#endif

#ifndef SC_ANYREFDG_HXX
#include "anyrefdg.hxx"
#endif

#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SVX_ACREDLIN_HXX
#include <bf_svx/ctredlin.hxx>
#endif

#ifndef _SVX_SIMPTABL_HXX
#include <bf_svx/simptabl.hxx>
#endif

#ifndef _SVARRAY_HXX
#define _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif

#ifndef SC_CHGTRACK_HXX
#include "chgtrack.hxx"
#endif

#ifndef SC_CHGVISET_HXX
#include "chgviset.hxx"
#endif

#ifndef _SV_TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif
namespace binfilter {

class ScViewData;
class ScDocument;

#define FLT_DATE_BEFORE		0
#define FLT_DATE_SINCE		1
#define FLT_DATE_EQUAL		2
#define FLT_DATE_NOTEQUAL	3
#define FLT_DATE_BETWEEN	4
#define FLT_DATE_SAVE		5


class ScViewEntryPtr
{
private:
	String*			pAction;
	String*			pPos;
	String*			pAuthor;
	String*			pDate;
	String*			pComment;
	void*			pData;

public:

	String*			GetpAction()	{return pAction; }
	String*			GetpPos()		{return pPos;    }
	String*			GetpAuthor()	{return	pAuthor; }
	String*			GetpDate()		{return	pDate;   }
	String*			GetpComment()	{return	pComment;}
	void*			GetpData()		{return pData;	 }

	void		SetpAction (String* pString)	{pAction= pString;}
	void		SetpPos    (String* pString)	{pPos	= pString;}
	void		SetpAuthor (String* pString)	{pAuthor= pString;}
	void		SetpDate   (String* pString)	{pDate	= pString;}
	void		SetpComment(String* pString)	{pComment=pString;}
	void		SetpData   (void*   pdata)		{pData	 =pdata;}
};

class ScViewEntryPtrList
{
	ScViewEntryPtrList* pNext;
	ScViewEntryPtrList* pLast;

	ScViewEntryPtr*	pData;
};


//STRIP001 class ScRedlinData : public RedlinData
//STRIP001 {
//STRIP001 public:
//STRIP001 
//STRIP001 					ScRedlinData();
//STRIP001 					~ScRedlinData();
//STRIP001 	USHORT			nTable;
//STRIP001 	USHORT			nCol;
//STRIP001 	USHORT			nRow;
//STRIP001 	ULONG			nActionNo;
//STRIP001 	ULONG			nInfo;
//STRIP001 	BOOL			bIsRejectable;
//STRIP001 	BOOL			bIsAcceptable;
//STRIP001 };

typedef	long LExpNum;

//@ Expand-Entrys nicht eindeutig, daher gestrichen
//DECLARE_TABLE( ScChgTrackExps, LExpNum)
//==================================================================

class ScAcceptChgDlg : public SfxModelessDialog
{
private:
//STRIP001 
//STRIP001 	Timer					aSelectionTimer;
//STRIP001 	Timer					aReOpenTimer;
//STRIP001 	SvxAcceptChgCtr 		aAcceptChgCtr;
//STRIP001 	ScViewData*				pViewData;
//STRIP001 	ScDocument*				pDoc;
//STRIP001 	ScRangeName				aLocalRangeName;
//STRIP001 	Selection				theCurSel;
//STRIP001 	SvxTPFilter*			pTPFilter;
//STRIP001 	SvxTPView*				pTPView;
//STRIP001 	SvxRedlinTable*			pTheView;
//STRIP001 	Size					MinSize;
//STRIP001 	ScRangeList				aRangeList;
//STRIP001 	ScChangeViewSettings	aChangeViewSet;
//STRIP001 	String					aStrInsertCols;
//STRIP001 	String					aStrInsertRows;
//STRIP001 	String					aStrInsertTabs;
//STRIP001 	String					aStrDeleteCols;
//STRIP001 	String					aStrDeleteRows;
//STRIP001 	String					aStrDeleteTabs;
//STRIP001 	String					aStrMove;
//STRIP001 	String					aStrContent;
//STRIP001 	String					aStrReject;
//STRIP001 	String					aUnknown;
//STRIP001 	String					aStrAllAccepted;
//STRIP001 	String					aStrAllRejected;
//STRIP001 	String					aStrNoEntry;
//STRIP001 	String					aStrContentWithChild;
//STRIP001 	String					aStrChildContent;
//STRIP001 	String					aStrChildOrgContent;
//STRIP001 	String					aStrEmpty;
//STRIP001 	ULONG					nAcceptCount;
//STRIP001 	ULONG					nRejectCount;
//STRIP001 	BOOL					bAcceptEnableFlag;
//STRIP001 	BOOL					bRejectEnableFlag;
//STRIP001 	BOOL					bNeedsUpdate;
//STRIP001 	BOOL					bIgnoreMsg;
//STRIP001 	BOOL					bNoSelection;
//STRIP001 	BOOL					bHasFilterEntry;
//STRIP001 	BOOL					bUseColor;
	//ScChgTrackExps			aExpandArray;

//STRIP001 	void			Init();
//STRIP001 	void			InitFilter();
//STRIP001 	void			SetMyStaticData();
//STRIP001 
//STRIP001 	DECL_LINK( FilterHandle, SvxTPFilter* );
//STRIP001 	DECL_LINK( RefHandle, SvxTPFilter* );
//STRIP001 	DECL_LINK( FilterModified, SvxTPFilter* );
//STRIP001 	DECL_LINK( MinSizeHandle, SvxAcceptChgCtr*);
//STRIP001 	DECL_LINK( RejectHandle, SvxTPView*);
//STRIP001 	DECL_LINK( AcceptHandle, SvxTPView*);
//STRIP001 	DECL_LINK( RejectAllHandle, SvxTPView*);
//STRIP001 	DECL_LINK( AcceptAllHandle, SvxTPView*);
//STRIP001 	DECL_LINK( ExpandingHandle, SvxRedlinTable*);
//STRIP001 	DECL_LINK( SelectHandle, SvxRedlinTable*);
//STRIP001 	DECL_LINK( RefInfoHandle, String*);
//STRIP001 
//STRIP001 	DECL_LINK( UpdateSelectionHdl, Timer*);
//STRIP001 	DECL_LINK( ChgTrackModHdl, ScChangeTrack*);
//STRIP001 	DECL_LINK( CommandHdl, Control*);
//STRIP001 	DECL_LINK( ReOpenTimerHdl, Timer*);
//STRIP001 	DECL_LINK( ColCompareHdl, SvSortData*);
//STRIP001 


protected:

//STRIP001 	virtual void	Resize();
//STRIP001 	virtual BOOL	Close();
//STRIP001 
//STRIP001 	void			RejectFiltered();
//STRIP001 	void			AcceptFiltered();
//STRIP001 
//STRIP001 	BOOL			IsValidAction(const ScChangeAction* pScChangeAction);
//STRIP001 
//STRIP001 	String*			MakeTypeString(ScChangeActionType eType);
//STRIP001 
//STRIP001 	SvLBoxEntry*	InsertChangeAction(const ScChangeAction* pScChangeAction,ScChangeActionState eState,
//STRIP001 									SvLBoxEntry* pParent=NULL,BOOL bDelMaster=FALSE,
//STRIP001 									BOOL bDisabled=FALSE,ULONG nPos=LIST_APPEND);
//STRIP001 
//STRIP001 	SvLBoxEntry*	InsertFilteredAction(const ScChangeAction* pScChangeAction,ScChangeActionState eState,
//STRIP001 									SvLBoxEntry* pParent=NULL,BOOL bDelMaster=FALSE,
//STRIP001 									BOOL bDisabled=FALSE,ULONG nPos=LIST_APPEND);
//STRIP001 
//STRIP001 
//STRIP001 	SvLBoxEntry*	InsertChangeActionContent(const ScChangeActionContent* pScChangeAction,
//STRIP001 											  SvLBoxEntry* pParent,ULONG nSpecial);
//STRIP001 
//STRIP001 	void			GetDependents( const ScChangeAction* pScChangeAction,
//STRIP001 								ScChangeActionTable& aActionTable,
//STRIP001 								SvLBoxEntry* pEntry);
//STRIP001 
//STRIP001 	BOOL			InsertContentChilds(ScChangeActionTable* pActionTable,SvLBoxEntry* pParent);
//STRIP001 
//STRIP001 	BOOL			InsertAcceptedORejected(SvLBoxEntry* pParent);
//STRIP001 
//STRIP001 	BOOL			InsertDeletedChilds(const ScChangeAction *pChangeAction, ScChangeActionTable* pActionTable,
//STRIP001 										SvLBoxEntry* pParent);
//STRIP001 
//STRIP001 	BOOL			InsertChilds(ScChangeActionTable* pActionTable,SvLBoxEntry* pParent);
//STRIP001 
//STRIP001 	void			AppendChanges(ScChangeTrack* pChanges,ULONG nStartAction, ULONG nEndAction,
//STRIP001 									ULONG nPos=LIST_APPEND);
//STRIP001 
//STRIP001 	void			RemoveEntrys(ULONG nStartAction,ULONG nEndAction);
//STRIP001 	void			UpdateEntrys(ScChangeTrack* pChgTrack, ULONG nStartAction,ULONG nEndAction);
//STRIP001 
//STRIP001 	void			UpdateView();
//STRIP001 	void			ClearView();
//STRIP001 
//STRIP001 	BOOL			Expand(ScChangeTrack* pChanges,const ScChangeAction* pScChangeAction,
//STRIP001 							SvLBoxEntry* pEntry, BOOL bFilter=FALSE);
//STRIP001 
public:
					ScAcceptChgDlg( SfxBindings* pB, SfxChildWindow* pCW, Window* pParent,
							   ScViewData*		ptrViewData);

					~ScAcceptChgDlg();

//STRIP001 	void			ReInit(ScViewData* ptrViewData);
//STRIP001 
//STRIP001 	virtual long	PreNotify( NotifyEvent& rNEvt );
//STRIP001 
//STRIP001 	void			Initialize (SfxChildWinInfo* pInfo);
//STRIP001 	virtual void    FillInfo(SfxChildWinInfo&) const;

};


} //namespace binfilter
#endif // SC_NAMEDLG_HXX

