/*************************************************************************
 *
 *  $RCSfile: sc_tabview5.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:36:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

// auto strip #include "scitems.hxx"
// auto strip #include <bf_svx/eeitem.hxx>
#define ITEMID_FIELD EE_FEATURE_FIELD

#include <bf_svx/fmshell.hxx>
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #include <bf_svx/svdoutl.hxx>
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #include <tools/ref.hxx>

// auto strip #include "tabview.hxx"
#include "tabvwsh.hxx"
#include "document.hxx"
#include "gridwin.hxx"
#include "olinewin.hxx"
#include "tabsplit.hxx"
#include "colrowba.hxx"
#include "tabcont.hxx"
#include "hintwin.hxx"
#include "bf_sc.hrc"
#include "pagedata.hxx"
#include "hiranges.hxx"
#include "drawview.hxx"
#include "drwlayer.hxx"
#include "fusel.hxx"                // Start-Function
#include "seltrans.hxx"
#include "scmod.hxx"
// auto strip #include "AccessibilityHints.hxx"
namespace binfilter {


// STATIC DATA -----------------------------------------------------------


/*M*/ void __EXPORT ScTabView::Init()
/*M*/ {
/*M*/ 	USHORT i;
/*M*/ 
/*M*/ 	aScrollTimer.SetTimeout(10);
/*M*/ 	aScrollTimer.SetTimeoutHdl( LINK( this, ScTabView, TimerHdl ) );
/*M*/ 
/*M*/ 	for (i=0; i<4; i++)
/*M*/ 		pGridWin[i] = NULL;
/*M*/ 	pGridWin[SC_SPLIT_BOTTOMLEFT] = new ScGridWindow( pFrameWin, &aViewData, SC_SPLIT_BOTTOMLEFT );
/*M*/ 
/*M*/ 	pSelEngine = new ScViewSelectionEngine( pGridWin[SC_SPLIT_BOTTOMLEFT], this,
/*M*/ 												SC_SPLIT_BOTTOMLEFT );
/*M*/ 	aFunctionSet.SetSelectionEngine( pSelEngine );
/*M*/ 
/*M*/ 	pHdrSelEng = new ScHeaderSelectionEngine( pFrameWin, &aHdrFunc );
/*M*/ 
/*M*/ 	pColBar[SC_SPLIT_LEFT] = new ScColBar( pFrameWin, &aViewData, SC_SPLIT_LEFT,
/*M*/ 												&aHdrFunc, pHdrSelEng );
/*M*/ 	pColBar[SC_SPLIT_RIGHT] = NULL;
/*M*/ 	pRowBar[SC_SPLIT_BOTTOM] = new ScRowBar( pFrameWin, &aViewData, SC_SPLIT_BOTTOM,
/*M*/ 												&aHdrFunc, pHdrSelEng );
/*M*/ 	pRowBar[SC_SPLIT_TOP] = NULL;
/*M*/ 	for (i=0; i<2; i++)
/*M*/ 		pColOutline[i] = pRowOutline[i] = NULL;
/*M*/ 
/*M*/ 	pHSplitter = new ScTabSplitter( pFrameWin, WinBits( WB_HSCROLL ), &aViewData );
/*M*/ 	pVSplitter = new ScTabSplitter( pFrameWin, WinBits( WB_VSCROLL ), &aViewData );
/*M*/ 
/*M*/     // SSA: override default keyboard step size to allow snap to row/column
/*M*/     pHSplitter->SetKeyboardStepSize( 1 );
/*M*/     pVSplitter->SetKeyboardStepSize( 1 );
/*M*/ 
/*M*/ 	pTabControl = new ScTabControl( pFrameWin, &aViewData );
/*M*/ 	//MI: nie! das war mal eine MUSS-Aenderung von MBA
/*M*/ 	//if (!aViewData.IsBasicView())
/*M*/ 	//	pTabControl->ToTop();		// ueber dem Splitter
/*M*/ 
/*M*/ 	InitScrollBar( aHScrollLeft,	MAXCOL+1 );
/*M*/ 	InitScrollBar( aHScrollRight,	MAXCOL+1 );
/*M*/ 	InitScrollBar( aVScrollTop, 	MAXROW+1 );
/*M*/ 	InitScrollBar( aVScrollBottom,	MAXROW+1 );
/*M*/ 
/*M*/     // SSA: --- RTL --- no mirroring for horizontal scrollbars, otherwise
/*M*/     // scroll direction will be wrong
/*M*/     aHScrollLeft.EnableRTL ( FALSE );
/*M*/     aHScrollRight.EnableRTL ( FALSE );
/*M*/ 
/*M*/ 	//	Hier noch nichts anzeigen (Show), weil noch falsch angeordnet ist
/*M*/ 	//	Show kommt dann aus UpdateShow beim ersten Resize
/*M*/ 	//		pTabControl, pGridWin, aHScrollLeft, aVScrollBottom,
/*M*/ 	//		aCornerButton, aScrollBarBox, pHSplitter, pVSplitter
/*M*/ 
/*M*/ 	//		Splitter
/*M*/ 
/*M*/ 	pHSplitter->SetSplitHdl( LINK( this, ScTabView, SplitHdl ) );
/*M*/ 	pVSplitter->SetSplitHdl( LINK( this, ScTabView, SplitHdl ) );
/*M*/ 
/*M*/ 	//	UpdateShow kommt beim Resize, oder bei Kopie einer bestehenden View aus dem ctor
/*M*/ 
/*M*/ 	pDrawActual = NULL;
/*M*/ 	pDrawOld	= NULL;
/*M*/ 
/*M*/ 			//	DrawView darf nicht im TabView - ctor angelegt werden,
/*M*/ 			//	wenn die ViewShell noch nicht konstruiert ist...
/*M*/ 			//	Das gilt auch fuer ViewOptionsHasChanged()
/*M*/ 
/*M*/ 	TestHintWindow();
/*M*/ }

/*N*/ __EXPORT ScTabView::~ScTabView()
/*N*/ {
/*N*/ 	USHORT i;
/*N*/ 
/*N*/ 	//	remove selection object
/*N*/ 	ScModule* pScMod = SC_MOD();
/*N*/ 	ScSelectionTransferObj* pOld = pScMod->GetSelectionTransfer();
/*N*/ 	if ( pOld && pOld->GetView() == this )
/*N*/ 	{
/*?*/ 		DBG_BF_ASSERT(0, "STRIP"); //STRIP001 pOld->ForgetView();
//STRIP001 /*?*/ 		pScMod->SetSelectionTransfer( NULL );
//STRIP001 /*?*/ 		TransferableHelper::ClearSelection( GetActiveWin() );		// may delete pOld
/*N*/ 	}
/*N*/ 
/*N*/ 	DELETEZ(pPageBreakData);
/*N*/ 	DELETEZ(pHighlightRanges);
/*N*/ 
/*N*/ 	DELETEZ(pDrawOld);
/*N*/ 	DELETEZ(pDrawActual);
/*N*/ 
/*N*/ 	aViewData.KillEditView();			// solange GridWin's noch existieren
/*N*/ 
/*N*/ 	DELETEZ(pInputHintWindow);
/*N*/ 
/*N*/ 	if (pDrawView)
/*N*/ 	{
/*N*/ 		for (i=0; i<4; i++)
/*N*/ 			if (pGridWin[i])
/*N*/ 			{
/*N*/ 				pDrawView->VCRemoveWin(pGridWin[i]);
/*N*/ 				pDrawView->DelWin(pGridWin[i]);
/*N*/ 			}
/*N*/ 
/*N*/ 		pDrawView->HidePagePvNum(0);
/*N*/ 		delete pDrawView;
/*N*/ 	}
/*N*/ 
/*N*/ 	delete pSelEngine;
/*N*/ 
/*N*/ 	for (i=0; i<4; i++)
/*N*/ 		delete pGridWin[i];
/*N*/ 
/*N*/ 	delete pHdrSelEng;
/*N*/ 
/*N*/ 	for (i=0; i<2; i++)
/*N*/ 	{
/*N*/ 		delete pColBar[i];
/*N*/ 		delete pRowBar[i];
/*N*/ 		delete pColOutline[i];
/*N*/ 		delete pRowOutline[i];
/*N*/ 	}
/*N*/ 
/*N*/ 	delete pHSplitter;
/*N*/ 	delete pVSplitter;
/*N*/ 
/*N*/ 	delete pTabControl;
/*N*/ }

/*N*/ void ScTabView::MakeDrawView( BYTE nForceDesignMode )
/*N*/ {
/*N*/ 	if (!pDrawView)
/*N*/ 	{
/*N*/ 		ScDrawLayer* pLayer = aViewData.GetDocument()->GetDrawLayer();
/*N*/ 		DBG_ASSERT(pLayer, "wo ist der DrawLayer ??");
/*N*/ 
/*N*/ 		USHORT i;
/*N*/ 		pDrawView = new ScDrawView( pGridWin[SC_SPLIT_BOTTOMLEFT], &aViewData );
/*N*/ 		for (i=0; i<4; i++)
/*N*/ 			if (pGridWin[i])
/*N*/ 			{
/*N*/ 				if ( SC_SPLIT_BOTTOMLEFT != (ScSplitPos)i )
/*?*/ 					pDrawView->AddWin(pGridWin[i]);
/*N*/ 				pDrawView->VCAddWin(pGridWin[i]);
/*N*/ 			}
/*N*/ 		pDrawView->RecalcScale();
/*N*/ 		for (i=0; i<4; i++)
/*N*/ 			if (pGridWin[i])
/*N*/ 			{
/*N*/ 				pGridWin[i]->SetMapMode(pGridWin[i]->GetDrawMapMode());
/*N*/ 
/*N*/ 				pGridWin[i]->Update();		// wegen Invalidate im DrawView ctor (ShowPage),
/*N*/ 											// damit gleich gezeichnet werden kann
/*N*/ 			}
/*N*/ 		SfxRequest aSfxRequest(SID_OBJECT_SELECT, 0,aViewData.GetViewShell()->GetPool());
/*N*/ 		SetDrawFuncPtr(new FuSelection( aViewData.GetViewShell(), GetActiveWin(), pDrawView,
/*N*/ 										pLayer,aSfxRequest));
/*N*/ 
/*N*/ 		//	#106334# used when switching back from page preview: restore saved design mode state
/*N*/ 		//	(otherwise, keep the default from the draw view ctor)
/*N*/ 		if ( nForceDesignMode != SC_FORCEMODE_NONE )
/*?*/ 			pDrawView->SetDesignMode( (BOOL)nForceDesignMode );
/*N*/ 
/*N*/ 		//	an der FormShell anmelden
/*N*/ 		FmFormShell* pFormSh = aViewData.GetViewShell()->GetFormShell();
/*N*/ 		if (pFormSh)
/*N*/ 			pFormSh->SetView(pDrawView);
/*N*/ 
/*N*/ 	    if (aViewData.GetViewShell()->HasAccessibilityObjects())
				{DBG_BF_ASSERT(0, "STRIP");} //STRIP001 /*?*/ 		    aViewData.GetViewShell()->BroadcastAccessibility(SfxSimpleHint(SC_HINT_ACC_MAKEDRAWLAYER));
/*N*/         
/*N*/ 	}
/*N*/ }

//STRIP001 void ScTabView::DoAddWin( ScGridWindow* pWin )
//STRIP001 {
//STRIP001 	if (pDrawView)
//STRIP001 	{
//STRIP001 		pDrawView->AddWin(pWin);
//STRIP001 		pDrawView->VCAddWin(pWin);
//STRIP001 	}
//STRIP001 }

//==================================================================

//STRIP001 void ScTabView::TabChanged()
//STRIP001 {
//STRIP001 	if (pDrawView)
//STRIP001 	{
//STRIP001 		DrawDeselectAll();		// beendet auch Text-Edit-Modus
//STRIP001 
//STRIP001 		USHORT i;
//STRIP001 		for (i=0; i<4; i++)
//STRIP001 			if (pGridWin[i])
//STRIP001 				pDrawView->VCRemoveWin(pGridWin[i]);	// fuer alte Page
//STRIP001 
//STRIP001 		USHORT nTab = aViewData.GetTabNo();
//STRIP001 		pDrawView->HideAllPages();
//STRIP001 		pDrawView->ShowPagePgNum( nTab, Point() );
//STRIP001 
//STRIP001 		UpdateLayerLocks();
//STRIP001 
//STRIP001 		pDrawView->RecalcScale();
//STRIP001 		pDrawView->UpdateWorkArea();	// #54782# PageSize ist pro Page unterschiedlich
//STRIP001 
//STRIP001 		for (i=0; i<4; i++)
//STRIP001 			if (pGridWin[i])
//STRIP001 				pDrawView->VCAddWin(pGridWin[i]);		// fuer neue Page
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxBindings& rBindings = aViewData.GetBindings();
//STRIP001 
//STRIP001 	//	Es gibt keine einfache Moeglichkeit, alle Slots der FormShell zu invalidieren
//STRIP001 	//	(fuer disablete Slots auf geschuetzten Tabellen), darum hier einfach alles...
//STRIP001 	rBindings.InvalidateAll(FALSE);
//STRIP001 
//STRIP001 #if 0
//STRIP001 	rBindings.Invalidate( SID_SELECT_SCENARIO );
//STRIP001 	rBindings.Invalidate( FID_PROTECT_TABLE );
//STRIP001 	rBindings.Invalidate( FID_DELETE_TABLE );
//STRIP001 	rBindings.Invalidate( FID_TABLE_SHOW );
//STRIP001 	rBindings.Invalidate( FID_TABLE_HIDE );
//STRIP001 
//STRIP001 				// Auswirkungen von geschuetzten Tabellen.
//STRIP001 	rBindings.Invalidate( FID_TAB_RENAME );
//STRIP001 	rBindings.Invalidate( FID_TAB_MOVE );
//STRIP001 	rBindings.Invalidate( SID_DEL_ROWS );
//STRIP001 	rBindings.Invalidate( SID_DEL_COLS );
//STRIP001 	rBindings.Invalidate( FID_INS_ROW );
//STRIP001 	rBindings.Invalidate( FID_INS_COLUMN );
//STRIP001 	rBindings.Invalidate( FID_INS_CELL );
//STRIP001 	rBindings.Invalidate( FID_INS_CELLSDOWN	);
//STRIP001 	rBindings.Invalidate( FID_INS_CELLSRIGHT );
//STRIP001 	rBindings.Invalidate( FID_DELETE_CELL );
//STRIP001 
//STRIP001 	rBindings.Invalidate( SID_OPENDLG_CHART );
//STRIP001 	rBindings.Invalidate( SID_INSERT_OBJECT );
//STRIP001 	rBindings.Invalidate( SID_INSERT_DIAGRAM );
//STRIP001 	rBindings.Invalidate( SID_INSERT_SMATH );
//STRIP001 	rBindings.Invalidate( SID_INSERT_GRAPHIC );
//STRIP001 #endif
//STRIP001 
//STRIP001 	if (aViewData.GetViewShell()->HasAccessibilityObjects())
//STRIP001 	{
//STRIP001 		SfxSimpleHint aAccHint(SC_HINT_ACC_TABLECHANGED);
//STRIP001 		aViewData.GetViewShell()->BroadcastAccessibility(aAccHint);
//STRIP001 	}
//STRIP001 }

/*N*/ void ScTabView::UpdateLayerLocks()
/*N*/ {
/*N*/ 	if (pDrawView)
/*N*/ 	{
/*N*/ 		USHORT nTab = aViewData.GetTabNo();
/*N*/ 		BOOL bEx = aViewData.GetViewShell()->IsDrawSelMode();
/*N*/ 		BOOL bProt = aViewData.GetDocument()->IsTabProtected( nTab ) ||
/*N*/ 					 aViewData.GetSfxDocShell()->IsReadOnly();
/*N*/ 
/*N*/ 		SdrLayer* pLayer;
/*N*/ 		SdrLayerAdmin& rAdmin = pDrawView->GetModel()->GetLayerAdmin();
/*N*/ 		pLayer = rAdmin.GetLayerPerID(SC_LAYER_BACK);
/*N*/ 		if (pLayer)
/*N*/ 			pDrawView->SetLayerLocked( pLayer->GetName(), bProt || !bEx );
/*N*/ 		pLayer = rAdmin.GetLayerPerID(SC_LAYER_INTERN);
/*N*/ 		if (pLayer)
/*N*/ 			pDrawView->SetLayerLocked( pLayer->GetName(), TRUE );
/*N*/ 		pLayer = rAdmin.GetLayerPerID(SC_LAYER_FRONT);
/*N*/ 		if (pLayer)
/*N*/ 			pDrawView->SetLayerLocked( pLayer->GetName(), bProt );
/*N*/ 		pLayer = rAdmin.GetLayerPerID(SC_LAYER_CONTROLS);
/*N*/ 		if (pLayer)
/*N*/ 			pDrawView->SetLayerLocked( pLayer->GetName(), bProt );
/*N*/ 	}
/*N*/ }

//STRIP001 void ScTabView::DrawDeselectAll()
//STRIP001 {
//STRIP001 	if (pDrawView)
//STRIP001 	{
//STRIP001 		ScTabViewShell* pViewSh = aViewData.GetViewShell();
//STRIP001 		if ( pDrawActual &&
//STRIP001 			( pViewSh->IsDrawTextShell() || pDrawActual->GetSlotID() == SID_DRAW_NOTEEDIT ) )
//STRIP001 		{
//STRIP001 			// end text edit (as if escape pressed, in FuDraw)
//STRIP001 			aViewData.GetDispatcher().Execute( pDrawActual->GetSlotID(),
//STRIP001 										SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD );
//STRIP001 		}
//STRIP001 
//STRIP001 		pDrawView->ScEndTextEdit();
//STRIP001 		pDrawView->UnmarkAll();
//STRIP001 
//STRIP001 		if (!pViewSh->IsDrawSelMode())
//STRIP001 			pViewSh->SetDrawShell( FALSE );
//STRIP001 	}
//STRIP001 }

//STRIP001 BOOL ScTabView::IsDrawTextEdit() const
//STRIP001 {
//STRIP001 	if (pDrawView)
//STRIP001 		return pDrawView->IsTextEdit();
//STRIP001 	else
//STRIP001 		return FALSE;
//STRIP001 }

//STRIP001 String ScTabView::GetSelectedChartName() const
//STRIP001 {
//STRIP001 	if (pDrawView)
//STRIP001 		return pDrawView->GetSelectedChartName();
//STRIP001 	else
//STRIP001 		return EMPTY_STRING;
//STRIP001 }

/*N*/ void ScTabView::SetZoom( const Fraction& rNewX, const Fraction& rNewY )
/*N*/ {
/*N*/ 	aViewData.SetZoom(rNewX,rNewY);
/*N*/ 	if (pDrawView)
/*N*/ 		pDrawView->RecalcScale();
/*N*/ 	ZoomChanged();				// einzeln wegen CLOOKs
/*N*/ }

//STRIP001 void ScTabView::SetPagebreakMode( BOOL bSet )
//STRIP001 {
//STRIP001 	aViewData.SetPagebreakMode(bSet);
//STRIP001 	if (pDrawView)
//STRIP001 		pDrawView->RecalcScale();
//STRIP001 	ZoomChanged();				// einzeln wegen CLOOKs
//STRIP001 }

//STRIP001 void ScTabView::ResetDrawDragMode()
//STRIP001 {
//STRIP001 	if (pDrawView)
//STRIP001 		pDrawView->SetDragMode( SDRDRAG_MOVE );
//STRIP001 }

/*N*/ void ScTabView::ViewOptionsHasChanged( BOOL bHScrollChanged, BOOL bGraphicsChanged )
/*N*/ {
/*N*/ 	//	DrawView erzeugen, wenn Gitter angezeigt werden soll
/*N*/ 	if ( !pDrawView && aViewData.GetOptions().GetGridOptions().GetGridVisible() )
			{DBG_BF_ASSERT(0, "STRIP");} //STRIP001 /*?*/ 		MakeDrawLayer();
/*N*/ 
/*N*/ 	if (pDrawView)
/*N*/ 		pDrawView->UpdateUserViewOptions();
/*N*/ 
/*N*/ 	if (bGraphicsChanged)
/*?*/ 		DrawEnableAnim(TRUE);	// DrawEnableAnim checks the options state
/*N*/ 
/*N*/ 	// if TabBar is set to visible, make sure its size is not 0
/*N*/ 	BOOL bGrow = ( aViewData.IsTabMode() && pTabControl->GetSizePixel().Width() <= 0 );
/*N*/ 
/*N*/ 	// if ScrollBar is set to visible, TabBar must make room
/*N*/ 	BOOL bShrink = ( bHScrollChanged && aViewData.IsTabMode() && aViewData.IsHScrollMode() &&
/*N*/ 						pTabControl->GetSizePixel().Width() > SC_TABBAR_DEFWIDTH );
/*N*/ 
/*N*/ 	if ( bGrow || bShrink )
/*N*/ 	{
/*?*/ 		Size aSize = pTabControl->GetSizePixel();
/*?*/ 		aSize.Width() = SC_TABBAR_DEFWIDTH;				// initial size
/*?*/ 		pTabControl->SetSizePixel(aSize);				// DoResize is called later...
/*N*/ 	}
/*N*/ }

// Helper-Funktion gegen das Include des Drawing Layers

/*N*/ SdrView* ScTabView::GetSdrView()
/*N*/ {
/*N*/ 	return pDrawView;
/*N*/ }

//STRIP001 void ScTabView::DrawMarkListHasChanged()
//STRIP001 {
//STRIP001 	if ( pDrawView )
//STRIP001 		pDrawView->MarkListHasChanged();
//STRIP001 }

//STRIP001 void ScTabView::UpdateAnchorHandles()
//STRIP001 {
//STRIP001 	if ( pDrawView )
//STRIP001 		pDrawView->AdjustMarkHdl();
//STRIP001 }

//STRIP001 void ScTabView::UpdateIMap( SdrObject* pObj )
//STRIP001 {
//STRIP001 	if ( pDrawView )
//STRIP001 		pDrawView->UpdateIMap( pObj );
//STRIP001 }

//STRIP001 void ScTabView::DrawMarkRect( const Rectangle& rRect )
//STRIP001 {
//STRIP001 	//!	store rectangle for repaint during drag
//STRIP001 
//STRIP001 	for (USHORT i=0; i<4; i++)
//STRIP001 	{
//STRIP001 		if ( pGridWin[i] && pGridWin[i]->IsVisible() )
//STRIP001 		{
//STRIP001 			RasterOp aROp = pGridWin[i]->GetRasterOp();
//STRIP001 			BOOL bHasLine = pGridWin[i]->IsLineColor();
//STRIP001 			Color aLine	  = pGridWin[i]->GetLineColor();
//STRIP001 			BOOL bHasFill = pGridWin[i]->IsFillColor();
//STRIP001 			Color aFill   = pGridWin[i]->GetFillColor();
//STRIP001 
//STRIP001 			pGridWin[i]->SetRasterOp( ROP_INVERT );
//STRIP001 			pGridWin[i]->SetLineColor( COL_BLACK );
//STRIP001 			pGridWin[i]->SetFillColor();
//STRIP001 
//STRIP001 			pGridWin[i]->DrawRect(rRect);
//STRIP001 
//STRIP001 			pGridWin[i]->SetRasterOp(aROp);
//STRIP001 			if (bHasLine)
//STRIP001 				pGridWin[i]->SetLineColor(aLine);
//STRIP001 			else
//STRIP001 				pGridWin[i]->SetLineColor();
//STRIP001 			if (bHasFill)
//STRIP001 				pGridWin[i]->SetFillColor(aFill);
//STRIP001 			else
//STRIP001 				pGridWin[i]->SetFillColor();
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

/*N*/ void ScTabView::DrawEnableAnim(BOOL bSet)
/*N*/ {
/*N*/ 	USHORT i;
/*N*/ 	if ( pDrawView )
/*N*/ 	{
/*N*/ 		//	#71040# dont start animations if display of graphics is disabled
/*N*/ 		//	graphics are controlled by VOBJ_TYPE_OLE
/*N*/ 		if ( bSet && aViewData.GetOptions().GetObjMode(VOBJ_TYPE_OLE) == VOBJ_MODE_SHOW )
/*N*/ 		{
/*N*/ 			if ( !pDrawView->IsAnimationEnabled() )
/*N*/ 			{
/*?*/ 				pDrawView->SetAnimationEnabled(TRUE);
/*?*/ 
/*?*/ 				//	Animierte GIFs muessen wieder gestartet werden:
/*?*/ 				ScDocument* pDoc = aViewData.GetDocument();
/*?*/ 				for (i=0; i<4; i++)
/*?*/ 					if ( pGridWin[i] && pGridWin[i]->IsVisible() )
/*?*/ 						{DBG_BF_ASSERT(0, "STRIP");} //STRIP001 pDoc->StartAnimations( aViewData.GetTabNo(), pGridWin[i] );
/*?*/ 			}
/*N*/ 		}
/*N*/ 		else
/*N*/ 		{
/*?*/ 			pDrawView->SetAnimationEnabled(FALSE);
/*?*/ 			//	StopAnimations am Dokument ist nicht mehr noetig
/*N*/ 		}
/*N*/ 	}
/*N*/ }

//STRIP001 void ScTabView::DrawShowMarkHdl(BOOL bShow)
//STRIP001 {
//STRIP001 	if (!pDrawView)
//STRIP001 		return;
//STRIP001 
//STRIP001 	if (bShow)
//STRIP001 	{
//STRIP001 		if (!pDrawView->IsDisableHdl())
//STRIP001 			pDrawView->ShowMarkHdl(NULL);
//STRIP001 	}
//STRIP001 	else
//STRIP001 		pDrawView->HideMarkHdl(NULL);
//STRIP001 }

//STRIP001 void ScTabView::UpdateDrawTextOutliner()
//STRIP001 {
//STRIP001 	if ( pDrawView )
//STRIP001 	{
//STRIP001 		Outliner* pOL = pDrawView->GetTextEditOutliner();
//STRIP001 		if (pOL)
//STRIP001 			aViewData.UpdateOutlinerFlags( *pOL );
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScTabView::DigitLanguageChanged()
//STRIP001 {
//STRIP001 	LanguageType eNewLang = SC_MOD()->GetOptDigitLanguage();
//STRIP001 	for (USHORT i=0; i<4; i++)
//STRIP001 		if ( pGridWin[i] )
//STRIP001 			pGridWin[i]->SetDigitLanguage( eNewLang );
//STRIP001 }

//---------------------------------------------------------------

/*N*/ void ScTabView::ScrollToObject( SdrObject* pDrawObj )
/*N*/ {
/*N*/ 	if ( pDrawObj )
			{DBG_BF_ASSERT(0, "STRIP");} //STRIP001 /*N*/ 		MakeVisible( pDrawObj->GetLogicRect() );
/*N*/ }

//STRIP001 void ScTabView::MakeVisible( const Rectangle& rHMMRect )
//STRIP001 {
//STRIP001 	Window* pWin = GetActiveWin();
//STRIP001 	Size aWinSize = pWin->GetOutputSizePixel();
//STRIP001 	USHORT nTab = aViewData.GetTabNo();
//STRIP001 
//STRIP001 	Rectangle aRect = pWin->LogicToPixel( rHMMRect );
//STRIP001 
//STRIP001 	long nScrollX=0, nScrollY=0;		// Pixel
//STRIP001 
//STRIP001 	if ( aRect.Right() >= aWinSize.Width() )				// rechts raus
//STRIP001 	{
//STRIP001 		nScrollX = aRect.Right() - aWinSize.Width() + 1;	// rechter Rand sichtbar
//STRIP001 		if ( aRect.Left() < nScrollX )
//STRIP001 			nScrollX = aRect.Left();						// links sichtbar (falls zu gross)
//STRIP001 	}
//STRIP001 	if ( aRect.Bottom() >= aWinSize.Height() )				// unten raus
//STRIP001 	{
//STRIP001 		nScrollY = aRect.Bottom() - aWinSize.Height() + 1;	// unterer Rand sichtbar
//STRIP001 		if ( aRect.Top() < nScrollY )
//STRIP001 			nScrollY = aRect.Top();							// oben sichtbar (falls zu gross)
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( aRect.Left() < 0 )				// links raus
//STRIP001 		nScrollX = aRect.Left();		// linker Rand sichtbar
//STRIP001 	if ( aRect.Top() < 0 )				// oben raus
//STRIP001 		nScrollY = aRect.Top();			// oberer Rand sichtbar
//STRIP001 
//STRIP001 	if (nScrollX || nScrollY)
//STRIP001 	{
//STRIP001 		ScDocument* pDoc = aViewData.GetDocument();
//STRIP001 		double nPPTX = aViewData.GetPPTX();
//STRIP001 		double nPPTY = aViewData.GetPPTY();
//STRIP001 		ScSplitPos eWhich = aViewData.GetActivePart();
//STRIP001 		USHORT nPosX = aViewData.GetPosX(WhichH(eWhich));
//STRIP001 		USHORT nPosY = aViewData.GetPosY(WhichV(eWhich));
//STRIP001 
//STRIP001 		long nLinesX=0, nLinesY=0;		// Spalten/Zeilen - um mindestens nScrollX/Y scrollen
//STRIP001 
//STRIP001 		if (nScrollX > 0)
//STRIP001 			while (nScrollX > 0 && nPosX < MAXCOL)
//STRIP001 			{
//STRIP001 				nScrollX -= (long) ( pDoc->GetColWidth(nPosX, nTab) * nPPTX );
//STRIP001 				++nPosX;
//STRIP001 				++nLinesX;
//STRIP001 			}
//STRIP001 		else if (nScrollX < 0)
//STRIP001 			while (nScrollX < 0 && nPosX > 0)
//STRIP001 			{
//STRIP001 				--nPosX;
//STRIP001 				nScrollX += (long) ( pDoc->GetColWidth(nPosX, nTab) * nPPTX );
//STRIP001 				--nLinesX;
//STRIP001 			}
//STRIP001 
//STRIP001 		if (nScrollY > 0)
//STRIP001 			while (nScrollY > 0 && nPosY < MAXROW)
//STRIP001 			{
//STRIP001 				nScrollY -= (long) ( pDoc->FastGetRowHeight(nPosY, nTab) * nPPTY );
//STRIP001 				++nPosY;
//STRIP001 				++nLinesY;
//STRIP001 			}
//STRIP001 		else if (nScrollY < 0)
//STRIP001 			while (nScrollY < 0 && nPosY > 0)
//STRIP001 			{
//STRIP001 				--nPosY;
//STRIP001 				nScrollY += (long) ( pDoc->FastGetRowHeight(nPosY, nTab) * nPPTY );
//STRIP001 				--nLinesY;
//STRIP001 			}
//STRIP001 
//STRIP001 		ScrollLines( nLinesX, nLinesY );					// ausfuehren
//STRIP001 	}
//STRIP001 }



}
