/*************************************************************************
 *
 *  $RCSfile: svx_nforient.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop
#include "nforient.hxx"
namespace binfilter {

//STRIP001 #define ORIENT_SPIN		5


//STRIP001 void SvxOrientationField::Init( short _nMin, short _nMax )
//STRIP001 {
//STRIP001 	SetStrictFormat( TRUE );
//STRIP001 	SetSpinSize( ORIENT_SPIN );
//STRIP001 	nMinVal = _nMin;
//STRIP001 	nMaxVal = _nMax;
//STRIP001 	SetMin( -_nMax );
//STRIP001 	SetMax( _nMax );
//STRIP001 }


/*************************************************************************
#*	Member:		SvxOrientationField							Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Konstruktor der Klasse SvxOrientationField
#*
#*  Input:		Parent-Window, WinBits, min. Winkel, max. Winkel
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 SvxOrientationField::SvxOrientationField( Window* pParent, WinBits nWinStyle, short _nMin, short _nMax ):
//STRIP001 	NumericField( pParent, nWinStyle )
//STRIP001 {
//STRIP001 	Init( _nMin, _nMax );
//STRIP001 }

/*************************************************************************
#*	Member:		SvxOrientationField							Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Konstruktor der Klasse SvxOrientationField
#*
#*  Input:		Parent-Window, Resource, min. Winkel, max. Winkel
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 SvxOrientationField::SvxOrientationField( Window* pWindow, const ResId& rResId, short _nMin, short _nMax ) :
//STRIP001 	NumericField( pWindow, rResId )
//STRIP001 {
//STRIP001 	Init( _nMin, _nMax );
//STRIP001 }

/*************************************************************************
#*	Member:		Up											Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Funktion, die aufgerufen wird, wenn der Spin-Button 'Up'
#*				ausgeloest wird. Sorgt fuer das dynamische Zaehlverhalten.
#*				Wenn der Max- Wert ueberschritten wird, so wird der Min-
#*				Wert eingestellt.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 void SvxOrientationField::Up()
//STRIP001 {
//STRIP001 	long	nVal = GetValue();
//STRIP001 	nVal += GetSpinSize();
//STRIP001 
//STRIP001 	if( nVal > nMaxVal )
//STRIP001 	{
//STRIP001 		nVal -= nMaxVal;
//STRIP001 		nVal--;
//STRIP001 	}
//STRIP001 
//STRIP001 	SetValue( nVal );
//STRIP001 
//STRIP001 	CtrPrivatModify();
//STRIP001 }

/*************************************************************************
#*	Member:		Down										Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Funktion, die aufgerufen wird, wenn der Spin-Button 'Down'
#*				ausgeloest wird. Sorgt fuer das dynamische Zaehlverhalten.
#*				Wenn der Min- Wert unterschritten wird, so wird der Max-
#*				Wert eingestellt.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 void SvxOrientationField::Down()
//STRIP001 {
//STRIP001 	long	nVal = GetValue();
//STRIP001 	nVal -= GetSpinSize();
//STRIP001 
//STRIP001 	if( nVal < nMinVal )
//STRIP001 	{
//STRIP001 		nVal += nMaxVal;
//STRIP001 		nVal++;
//STRIP001 	}
//STRIP001 
//STRIP001 	SetValue( nVal );
//STRIP001 	CtrPrivatModify();
//STRIP001 
//STRIP001 }

/*************************************************************************
#*	Member:		Modify										Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Wird aufgerufen, wenn das Editfeld geaendert wurde.
#*				Es werden die letzten beiden Werte gespeichert.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 void SvxOrientationField::Modify()
//STRIP001 {
//STRIP001 	NumericField::Modify();
//STRIP001 	CtrPrivatModify();
//STRIP001 }

/*************************************************************************
#*	Member:		CtrModified									Datum:20.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Teilt einem installierten Handler mit, dass
#*				eine Veraenderung eingetreten ist.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/
//STRIP001 void SvxOrientationField::CtrPrivatModify()
//STRIP001 {
//STRIP001 	aPrivModifyLink.Call( this );
//STRIP001 }


}
