/*************************************************************************
 *
 *  $RCSfile: sw_wview.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:39:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#include "itemdef.hxx"

// auto strip #ifndef _SVX_SRCHITEM_HXX
// auto strip #include <bf_svx/srchitem.hxx>
// auto strip #endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
#ifndef _SFX_TEMPLDLG_HXX //autogen
#include <bf_sfx2/templdlg.hxx>
#endif
#ifndef _SVX_SRCHDLG_HXX //autogen
#include <bf_svx/srchdlg.hxx>
#endif
// auto strip #ifndef _SBX_SBXOBJECT_HXX //autogen
// auto strip #include <svtools/sbxobj.hxx>
// auto strip #endif
// auto strip #ifndef _UIVWIMP_HXX
// auto strip #include <uivwimp.hxx>
// auto strip #endif
#ifndef _SVX_FMSHELL_HXX //autogen
#include <bf_svx/fmshell.hxx>
#endif
// auto strip #ifndef _SFXENUMITEM_HXX //autogen
// auto strip #include <svtools/eitem.hxx>
// auto strip #endif


// auto strip #ifndef _SWMODULE_HXX //autogen
// auto strip #include <swmodule.hxx>
// auto strip #endif
// auto strip #ifndef _UNOTXVW_HXX //autogen
// auto strip #include <unotxvw.hxx>
// auto strip #endif
// auto strip #include "swtypes.hxx"
#include "cmdid.h"
#include "globals.hrc"

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #include "wrtsh.hxx"
// auto strip #include "edtwin.hxx"
// auto strip #include "wgrfsh.hxx"
// auto strip #include "wfrmsh.hxx"
// auto strip #include "wolesh.hxx"
// auto strip #include "wtabsh.hxx"
// auto strip #include "wlistsh.hxx"
// auto strip #include "wformsh.hxx"
// auto strip #include "wtextsh.hxx"
// auto strip #include "barcfg.hxx"
// auto strip #include "doc.hxx"

// EIGENTLICH nicht moeglich !!
// auto strip #include "beziersh.hxx"
// auto strip #include "drawsh.hxx"
// auto strip #include "drwtxtsh.hxx"

#include "wview.hxx"
#include "wdocsh.hxx"
#include "web.hrc"
#include "shells.hrc"
namespace binfilter {

#define SwWebView
#define SearchAttributes
#define ReplaceAttributes
#define SearchSettings
#define _ExecSearch ExecSearch
#define _StateSearch StateSearch
#define Frames
#define Graphics
#define OLEObjects
#define Controls
#define Text
#define Frame
#define Graphic
#define Object
#define Draw
#define DrawText
#define TextInTable
#define ListInText
#define ListInTable
#define Page
// auto strip #include <bf_svx/svxslots.hxx>
#include "swslots.hxx"


/*N*/ SFX_IMPL_VIEWFACTORY(SwWebView, SW_RES(STR_NONAME))
/*N*/ {
/*N*/ 	SFX_VIEW_REGISTRATION(SwWebDocShell);
/*N*/ }


/*N*/ SFX_IMPL_INTERFACE( SwWebView, SwView, SW_RES(RID_WEBTOOLS_TOOLBOX) )
/*N*/ {
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(SfxTemplateDialogWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(SvxSearchDialogWrapper::GetChildWindowId());
/*N*/ 	SFX_OBJECTBAR_REGISTRATION(	SFX_OBJECTBAR_TOOLS|
/*N*/ 								SFX_VISIBILITY_STANDARD|SFX_VISIBILITY_SERVER,
/*N*/ 								SW_RES(RID_WEBTOOLS_TOOLBOX) );
/*N*/ }

/*N*/ TYPEINIT1(SwWebView,SwView)

/*-----------------22.01.97 14.27-------------------

--------------------------------------------------*/


/*?*/ SwWebView::SwWebView(SfxViewFrame* pFrame, SfxViewShell* pShell) :
/*?*/ 	SwView(pFrame, pShell)
/*?*/ {
/*?*/ }

/*-----------------22.01.97 14.27-------------------

--------------------------------------------------*/


/*?*/ SwWebView::~SwWebView()
/*?*/ {
/*?*/ }

/*-----------------23.01.97 09.01-------------------

--------------------------------------------------*/


//STRIP001 void SwWebView::SelectShell()
//STRIP001 {
//STRIP001 	// Entscheidung, ob UpdateTable gerufen werden muss
//STRIP001 	BOOL bUpdateTable = FALSE;
//STRIP001 	const SwFrmFmt* pCurTableFmt = GetWrtShell().GetTableFmt();
//STRIP001 	if(pCurTableFmt && pCurTableFmt != GetLastTblFrmFmt())
//STRIP001 	{
//STRIP001 		bUpdateTable = TRUE; // kann erst spaeter ausgefuehrt werden
//STRIP001 	}
//STRIP001 	SetLastTblFrmFmt(pCurTableFmt);
//STRIP001 	//SEL_TBL und SEL_TBL_CELLS koennen verodert sein!
//STRIP001 	int nNewSelectionType = (GetWrtShell().GetSelectionType()
//STRIP001 								& ~SwWrtShell::SEL_TBL_CELLS);
//STRIP001 
//STRIP001 	int nSelectionType = GetSelectionType();
//STRIP001 	if ( nNewSelectionType == nSelectionType )
//STRIP001 	{
//STRIP001 		GetViewFrame()->GetBindings().InvalidateAll( FALSE );
//STRIP001 		if ( nSelectionType & SwWrtShell::SEL_OLE ||
//STRIP001 			 nSelectionType & SwWrtShell::SEL_GRF )
//STRIP001 			//Fuer Grafiken und OLE kann sich natuerlich das Verb aendern!
//STRIP001 			ImpSetVerb( nNewSelectionType );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 
//STRIP001 	//	DELETEZ(pxSelectionObj); //Selektionsobjekt loeschen
//STRIP001 		SfxDispatcher &rDispatcher = *GetViewFrame()->GetDispatcher();
//STRIP001 		SwToolbarConfigItem *pBarCfg = SW_MOD()->GetWebToolbarConfig();
//STRIP001 
//STRIP001 		if( GetCurShell() )
//STRIP001 		{
//STRIP001 			rDispatcher.Flush();		// alle gecachten Shells wirklich loeschen
//STRIP001 
//STRIP001 			//Zur alten Selektion merken welche Toolbar sichtbar war
//STRIP001 			USHORT nId = rDispatcher.GetObjectBarId( SFX_OBJECTBAR_OBJECT );
//STRIP001 			if ( nId )
//STRIP001 				pBarCfg->SetTopToolbar( nSelectionType, nId );
//STRIP001 
//STRIP001 			SfxShell *pSfxShell;
//STRIP001 			USHORT i;
//STRIP001 			for ( i = 0; TRUE; ++i )
//STRIP001 			{
//STRIP001 				pSfxShell = rDispatcher.GetShell( i );
//STRIP001 				if ( !(pSfxShell->ISA( SwBaseShell ) ||
//STRIP001 					pSfxShell->ISA( SwDrawTextShell )) )
//STRIP001 					break;
//STRIP001 			}
//STRIP001 			pSfxShell = rDispatcher.GetShell( --i );
//STRIP001 			ASSERT( pSfxShell, "My Shell ist lost in space" );
//STRIP001 			rDispatcher.Pop( *pSfxShell, SFX_SHELL_POP_UNTIL | SFX_SHELL_POP_DELETE);
//STRIP001 		}
//STRIP001 
//STRIP001 		FASTBOOL bInitFormShell = FALSE;
//STRIP001 		if( !GetFormShell() )
//STRIP001 		{
//STRIP001 			bInitFormShell = TRUE;
//STRIP001 			SetFormShell( new FmFormShell( this ) );
//STRIP001 			rDispatcher.Push( *GetFormShell() );
//STRIP001 		}
//STRIP001 
//STRIP001 		FASTBOOL bSetExtInpCntxt = FALSE;
//STRIP001 		nSelectionType = nNewSelectionType;
//STRIP001 		SetSelectionType( nSelectionType );
//STRIP001 		ShellModes eShellMode;
//STRIP001 
//STRIP001 		if ( nSelectionType & SwWrtShell::SEL_OLE )
//STRIP001 		{
//STRIP001 			eShellMode = SEL_OBJECT;
//STRIP001 			SetShell( new SwWebOleShell( *this ));
//STRIP001 			rDispatcher.Push( *GetCurShell() );
//STRIP001 		}
//STRIP001 		else if ( nSelectionType & SwWrtShell::SEL_FRM
//STRIP001 			|| nSelectionType & SwWrtShell::SEL_GRF)
//STRIP001 		{
//STRIP001 			eShellMode = SEL_FRAME;
//STRIP001 			SetShell( new SwWebFrameShell( *this ));
//STRIP001 			rDispatcher.Push( *GetCurShell() );
//STRIP001 			if(nSelectionType & SwWrtShell::SEL_GRF )
//STRIP001 			{
//STRIP001 				eShellMode = SEL_GRAPHIC;
//STRIP001 				SetShell( new SwWebGrfShell( *this ));
//STRIP001 				rDispatcher.Push( *GetCurShell() );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if ( nSelectionType & SwWrtShell::SEL_FRM )
//STRIP001 		{
//STRIP001 			eShellMode = SEL_FRAME;
//STRIP001 			SetShell( new SwWebFrameShell( *this ));
//STRIP001 			rDispatcher.Push( *GetCurShell() );
//STRIP001 		}
//STRIP001 		else if ( nSelectionType & SwWrtShell::SEL_DRW )
//STRIP001 		{
//STRIP001 			eShellMode = SEL_DRAW;
//STRIP001 			SetShell( new SwDrawShell( *this ));
//STRIP001 			rDispatcher.Push( *GetCurShell() );
//STRIP001 			if ( nSelectionType & SwWrtShell::SEL_BEZ )
//STRIP001 			{
//STRIP001 				eShellMode = SEL_BEZIER;
//STRIP001 				SetShell( new SwBezierShell( *this ));
//STRIP001 				rDispatcher.Push( *GetCurShell() );
//STRIP001 			}
//STRIP001 
//STRIP001 		}
//STRIP001 		else if ( nSelectionType & SwWrtShell::SEL_DRW_FORM )
//STRIP001 		{
//STRIP001 			eShellMode = SEL_DRAW_FORM;
//STRIP001 			SetShell( new SwWebDrawFormShell( *this ));
//STRIP001 
//STRIP001 			rDispatcher.Push( *GetCurShell() );
//STRIP001 		}
//STRIP001 		else if ( nSelectionType & SwWrtShell::SEL_DRW_TXT )
//STRIP001 		{
//STRIP001 			eShellMode = SEL_DRAWTEXT;
//STRIP001 			rDispatcher.Push( *(new SwBaseShell( *this )) );
//STRIP001 			SetShell( new SwDrawTextShell( *this ));
//STRIP001 			rDispatcher.Push( *GetCurShell() );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			bSetExtInpCntxt = TRUE;
//STRIP001 			eShellMode = SEL_TEXT;
//STRIP001 			if ( nSelectionType & SwWrtShell::SEL_NUM )
//STRIP001 			{
//STRIP001 				eShellMode = SEL_LIST_TEXT;
//STRIP001 				SetShell( new SwWebListShell( *this ));
//STRIP001 				rDispatcher.Push( *GetCurShell() );
//STRIP001 			}
//STRIP001 			SetShell( new SwWebTextShell(*this));
//STRIP001 			rDispatcher.Push( *GetCurShell() );
//STRIP001 			if ( nSelectionType & SwWrtShell::SEL_TBL )
//STRIP001 			{
//STRIP001 				eShellMode = eShellMode == SEL_LIST_TEXT ? SEL_TABLE_LIST_TEXT
//STRIP001 														: SEL_TABLE_TEXT;
//STRIP001 				SetShell( new SwWebTableShell( *this ));
//STRIP001 				rDispatcher.Push( *GetCurShell() );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		ImpSetVerb( nSelectionType );
//STRIP001 		GetViewImpl()->SetShellMode(eShellMode);
//STRIP001 
//STRIP001 		if( !GetDocShell()->IsReadOnly() )
//STRIP001 		{
//STRIP001 			if( bSetExtInpCntxt && GetWrtShell().HasReadonlySel() )
//STRIP001 				bSetExtInpCntxt = FALSE;
//STRIP001 
//STRIP001 			InputContext aCntxt( GetEditWin().GetInputContext() );
//STRIP001 			aCntxt.SetOptions( bSetExtInpCntxt
//STRIP001 								? (aCntxt.GetOptions() |
//STRIP001 										( INPUTCONTEXT_TEXT |
//STRIP001 											INPUTCONTEXT_EXTTEXTINPUT ))
//STRIP001 								: (aCntxt.GetOptions() & ~
//STRIP001 										( INPUTCONTEXT_TEXT |
//STRIP001 											INPUTCONTEXT_EXTTEXTINPUT )) );
//STRIP001 			GetEditWin().SetInputContext( aCntxt );
//STRIP001 		}
//STRIP001 
//STRIP001 		//Zur neuen Selektion die Toolbar aktivieren, die auch beim letzten Mal
//STRIP001 		//aktiviert war
//STRIP001 		//Vorher muss ein Flush() sein, betrifft aber lt. MBA nicht das UI und ist
//STRIP001 		//kein Performance-Problem
//STRIP001 		rDispatcher.Flush();
//STRIP001 		USHORT nId = pBarCfg->GetTopToolbar( nSelectionType );
//STRIP001 		if ( USHRT_MAX != nId )
//STRIP001 			rDispatcher.ShowObjectBar( nId );
//STRIP001 
//STRIP001 		Point aPnt = GetEditWin().GetPointerPosPixel();
//STRIP001 		aPnt = GetEditWin().PixelToLogic(aPnt);
//STRIP001 		GetEditWin().UpdatePointer(aPnt);
//STRIP001 
//STRIP001 		if ( bInitFormShell && GetWrtShell().GetDrawView() )
//STRIP001 			GetFormShell()->SetView( PTR_CAST( FmFormView,
//STRIP001 												GetWrtShell().GetDrawView()));
//STRIP001 
//STRIP001 
//STRIP001 	}
//STRIP001 	GetViewImpl()->GetUNOObject_Impl()->NotifySelChanged();
//STRIP001 
//STRIP001 	//Guenstiger Zeitpunkt fuer die Kommunikation mit OLE-Objekten?
//STRIP001 	if ( GetDocShell()->GetDoc()->IsOLEPrtNotifyPending() )
//STRIP001 		GetDocShell()->GetDoc()->PrtOLENotify( FALSE );
//STRIP001 
//STRIP001 	//jetzt das Tabellen-Update
//STRIP001 	if(bUpdateTable)
//STRIP001 		GetWrtShell().UpdateTable();
//STRIP001 }




}
